#Demonstrationen fuer Vorlesung WS 04/05

#26.10.00
#Eingabe, Zeitreihenplot, log-Transformation
data("lynx")#Laedt den Datensatz lynx dazu
str(lynx)#Zeigt die Struktur des Datensatzes lynx an

plot(lynx,ylab="Anzahl Luchse",xlab="Zeit in Jahren")
plot(log(lynx),ylab="log Anzahl Luchse",xlab="Zeit in Jahren")
plot(log(lynx),type="b",ylab="log Anzahl Luchse",xlab="Zeit in Jahren")

data("sunspots")  #Laedt den Datensatz lynx dazu
str(sunspots)
plot(sunspots)
p.ts(sunspots, nr=5)  #Plot aufgeteilt auf nr = Fenster (Befehl aus SfS)

airline <- ts(scan("http://stat.ethz.ch/Teaching/Datasets/airline.dat"),start=c(1949,1),freq=12)

save(airline,file="airline.RData")  #da Demonstration nicht am Netz
load("airline.RData")               #da Demonstration nicht am Netz

plot(airline)
plot(log(airline))

#2. Differenzenbildung
plot(diff(log(airline))) #gewoehnliche Differenzen

airl.diff <- diff(log(airline))
plot(airl.diff)
plot(diff(airl.diff,lag=12))

plot(diff(diff(log(airline)),lag=12)) #saisonale und gewoehnliche Differenzen

#3. nichtparametrische Zerlegung in Komponenten
airl.stl1 <- stl(log(airline))
airl.stl1 <- stl(log(airline),s.window=7,t.window=21)
plot(airl.stl1)

airl.stl2 <- stl(log(airline),s.window=7,t.window=21,robust=T)
plot(airl.stl2)

airl.stl3 <- stl(log(airline),s.window="periodic")
plot(airl.stl3)

#Untersuche die Effekte von Ausreissern, z.B.
airline.contam <- airline
airline.contam[73] <- 642

airl.stl4 <- stl(log(airline.contam),s.window="periodic")
airl.stl5 <- stl(log(airline.contam),s.window="periodic",robust=T)

plot(airl.stl4)
plot(airl.stl5)

airl.stl.season <- ts.union(airl.stl4$time.series[,1],airl.stl5$time.series[,1])
plot(airl.stl.season,main="Saison-Effekte: robust (unten)")

airl.stl.trend <- ts.union(airl.stl4$time.series[,2],airl.stl5$time.series[,2])
plot(airl.stl.trend,main="Trend: robust (unten)")

plot(airl.stl.trend,plot.type="s",col=1:2,main="Trend: robust (rot)")

#Vergleich Differenzenbildung und Elimination mit stl:
airl.irregular <- airl.stl3$time.series[,3]  #Extrahieren des irregulaeren Teils
plot(ts.union(diff(diff(log(airline)),lag=12),airl.irregular),main="Irregulaerer Teil: Differenzen (oben), `stl' (unten)")
plot(ts.union(diff(diff(log(airline)),lag=12),airl.irregular),plot.type="s",col=c(2,4),main="Irregulaerer Teil: Differenzen (rot)), `stl' (blau)")


#4. Simulation von Irrfahrt und AR(1)-Prozessen
help(filter)#erklaert genauer, was die Funktion filter macht.
x <- filter(ts(rnorm(1000)),filter=1,method="recursive",init=rnorm(1))
                                #erzeugt X[t] = X[t-1] + eps[t]
plot(x)
