##18. Jan. 2005

#1. Glaettung des Periodogramms: Verwendung der Funktion spec.pgram
ocw <- ts(scan("http://stat.ethz.ch/Teaching/Datasets/ocwave.dat"))
load("ocwave.RData")
ocw <- ocwave
plot(ocw)

?spec.pgram

par(mfrow=c(2,1))
spec.pgram(ocw)
spec.pgram(ocw,detrend=F)

spec.pgram(ocw)
spec.pgram(ocw,demean=T,detrend=F)

#Tapering zur Reduktion von Bias aber Erhoehung der Varianz
spec.pgram(ocw)
spec.pgram(ocw,taper=0)
spec.pgram(ocw)

par(mfrow=c(1,1))
sp  <- spec.pgram(ocw,spans=5)
#Modifiziere das Argument spans (2 ungerade Zahlen)
sp$kernel$coef

data("lynx")
spec.pgram(log(lynx))
sp <- spec.pgram(log(lynx),spans=c(3,3))
sp$kernel$coef

# Zur Identifikation der Perioden, die zu Gipfeln im Spektrum gehoeren
gipfel <- identify(sp$freq,sp$spec)

1/sp$freq[gipfel]  #Quasi-Perioden in Jahren
 

data("sunspots")
spec.pgram(sunspots)
sp <- spec.pgram(sunspots,spans=c(11,11),taper=0.1)
# Zur Identifikation der Perioden, die zu Gipfeln im Spektrum gehoeren
gipfel <- identify(sp$freq,sp$spec)


1/sp$freq[gipfel]  #in Jahren


#2. Spektrum aus ueberlappenden Teilsegmenten

#10 Teilstuecke fuer ocwave
sp <- spec.pgram(ocw[1:128],detrend=F,ylim=c(0.01,10^8))
averaged <- sp$spec
for(i in 2:8)
  {
    spi <- spec.pgram(ocw[((i-1)*128 + 1):(i*128)],detrend=F,plot=F)
    lines(sp$freq,spi$spec,col=i)
    averaged <- averaged + spi$spec
    #lines(sp$freq,10*log(spi$spec,base=10),col=i)
  }

averaged <- averaged/8

par(mfrow=c(1,1))
sp1 <- spec.pgram(ocw,detrend=F,ylim=c(0.01,10^8))
sp2 <- spec.pgram(ocw,detrend=F,ylim=c(0.01,10^8),spans=9,plot=F)
lines(sp1$freq,sp2$sp,col=4)
lines(sp$freq,averaged,col=2)


#mit kuenstlichem Trend
ocw1 <- 0.1*(1:1024) + 0.00001*(1:1024)^3 + ocw
plot(ocw1)
sp <- spec.pgram(ocw1[1:128],detrend=F,ylim=c(0.01,10^8))
averaged <- sp$spec
for(i in 2:8)
  {
    spi <- spec.pgram(ocw1[((i-1)*128 + 1):(i*128)],detrend=F,plot=F)
    lines(sp$freq,spi$spec,col=i)
    averaged <- averaged + spi$spec
    #lines(sp$freq,10*log(spi$spec,base=10),col=i)
  }

averaged <- averaged/8

sp1 <- spec.pgram(ocw,detrend=F,ylim=c(0.01,10^8))
sp2 <- spec.pgram(ocw,detrend=F,ylim=c(0.01,10^8),spans=9,plot=F)
lines(sp1$freq,sp2$sp,col=4)
lines(sp$freq,averaged,col=2)

#Spektrum des Trends
x <- as.ts(0.1*(1:1024) + 0.00001*(1:1024)^3)
plot(x)

spec.pgram(x)
       #Trends "induzieren" Spektrum 

acf(x)

