#2. Nov. 2004

#1. Simulation von Irrfahrt und AR(1)-Prozessen
help(filter)   #erklaert genauer, was die Funktion filter macht.

phi <- 1
x <- filter(ts(rnorm(1000)),filter=phi,method="recursive",init=rnorm(1))
                                #erzeugt X[t] = phi*X[t-1] + eps[t]
plot(x)

phi <- 1
par(mfrow=c(3,3))
for(i in 1:9)
  {
    x <- filter(ts(rnorm(1000)),filter=phi,method="recursive",init=rnorm(1))
                                #erzeugt X[t] = phi*X[t-1] + eps[t]
    plot(x,ylim=c(-100,100))
  }


#Verteilung von AR(1) mit phi = 1 und mit phi = 0.8
set.seed(1)
phi <- 1
res.phi1 <- matrix(0,ncol=1000,nrow=500)
for(i in 1:500)
  {
    res.phi1[i,] <- filter(ts(rnorm(1000)),filter=phi,method="recursive",init=rnorm(1))
  }

set.seed(1)
phi <- 0.8
res.phi08 <- matrix(0,ncol=1000,nrow=500)
for(i in 1:500)
  {
    res.phi08[i,] <- filter(ts(rnorm(1000)),filter=phi,method="recursive",init=rnorm(1))
  }

par(mfrow=c(2,2))
hist(res.phi1[,1:50],xlim=c(-100,100),main="phi=1,t=1-50")
hist(res.phi1[,950:1000],xlim=c(-100,100),main="phi=1,t=950-1000")

hist(res.phi08[,1:50],xlim=c(-7,7),main="phi=0.8,t=1-50")
hist(res.phi08[,950:1000],xlim=c(-7,7),main="phi=0.8,t=950-1000")

#Reduktion auf Stationaritaet bei phi = 1:
phi <- 1
x <- filter(ts(rnorm(1000)),filter=phi,method="recursive",init=rnorm(1))

par(mfrow=c(2,2))
plot(x)

x.diff <- diff(x,lag=1)
plot(x.diff)
x.stl <- stl(x)  #--> geht nicht

x.trend <- lowess(1:1000,x)
plot(x)
lines(x.trend,col=2)
x.irreg <- x - x.trend$y
plot(x.irreg)

#2. Autokorrelation

phi <- 0.5
x <- filter(ts(rnorm(1000)),filter=phi,method="recursive",init=rnorm(1))
par(mfrow=c(1,1))
acf(x)
acf(x,type="covariance")

data(sunspots)
plot(sunspots)
acf(sunspots)

data(lynx)
plot(lynx)
acf(lynx)
acf(log(lynx))
acf(lynx^2)

#ARCH-Prozesse
f.arch.sim <- function(n=500,init=200,a)
{
  ## Purpose: Simulating the Arch(1) process
  ## -------------------------------------------------------------------------
  ## Arguments: n=length of the series, init=length of the initial segment
  ## that is discarded, a= Parameter of the model
  ## -------------------------------------------------------------------------
  ## Author: Hans-Ruedi Kuensch, Date:  5 Feb 97, 16:49
m <- n+init
x <- rnorm(m)
for (i in (2:m)) x[i] <- sqrt(1+a*x[i-1]^2)*x[i]
ts(x[(init+1):m],start=1)}

plot(f.arch.sim(n=1000,a=0.9))
#Variiere den Parameter und beschreiben das qualitative Verhalten

set.seed(22)
x.arch <- f.arch.sim(n=1000,a=0.8)
par(mfrow=c(1,2))
acf(x.arch)
acf(x.arch^2)

bmw <- ts(scan("ftp://ftp.stat.math.ethz.ch/Teaching/buhlmann/Zeitreihen/bmw.dat"))
save(bmw,file="bmw.RData")  #da Demonstration nicht am Netz
load("bmw.RData")               #da Demonstration nicht am Netz

par(mfrow=c(1,1))
plot(bmw,main="Tages-Returns von BMW Aktie")

par(mfrow=c(1,2))
acf(bmw)
acf(bmw^2)

