##23.11.2004

#1. Simulation von AR-Prozessen
?arima.sim

set.seed(22)
x <- arima.sim(500,model=list(ar=0.9))
acf(x)
plot(x)
qqnorm(x)


set.seed(22)
eps <- rt(1000,2)  #t-Vert. mit 2 Freiheitsgraden
x.t4 <- arima.sim(500,model=list(ar=0.9),innov=eps)
plot(x.t4)
par(mfrow=c(1,2))
qqnorm(eps[501:1000],ylim=c(-35,40))
qqnorm(x.t4,ylim=c(-35,40))

x <- arima.sim(500,model=list(ar=c(0.9,-0.8)))
par(mfrow=c(1,1))
plot(x)
acf(x)

##Nullstellen von AR-Polynom
ns.ar <- function(ar = NULL,ma = NULL)
{
  ## Purpose: berechnet Nullstellen von AR- und MA-Polynom
  ## -------------------------------------------------------------------------
  ## Arguments: AR- und MA-Koeffizienten
  ## -------------------------------------------------------------------------
  ## Author: Peter Buehlmann, Date: 18 Dec 2000, 11:05
abs(polyroot(c(1,- ar)))
}


ns.ar(c(0.9,-0.8))
[1] 1.118034 1.118034


#sunspot data
data(sunspots)

par(mfrow=c(1,1))
plot(sunspots)

fit <- ar.yw(sunspots)  #Schaetzung eines AR-Modells mit Yule-Walker
fit

plot(fit$ar,ylab="",main="AR-Koeffizienten")

ns.ar(fit$ar)

resid <- fit$res[29:length(sunspots)]
plot(resid)
lines(lowess(1:length(resid),resid),col=2)
acf(resid)
qqnorm(resid)

set.seed(22)
par(mfrow=c(2,3))
for(i in 1:5)
  {
    eps <- resid[sample(1:length(resid),replace=F)]
    plot(arima.sim(length(sunspots)-28,model=list(ar=fit$ar),innov=eps))
  }
plot(ts(sunspots[29:length(sunspots)]))

par(mfrow=c(1,1))
acf(resid^2)
acf(abs(resid))


data(UKLungDeaths)  #Monthly Deaths from Lung Diseases in the UK

plot(log(ldeaths))
fit <- ar.yw(log(ldeaths))

fit$ar

ns.ar(fit$ar)

resid <- fit$res[6:length(ldeaths)]
plot(resid)
lines(lowess(1:length(resid),resid),col=2)
acf(resid)
qqnorm(resid)

set.seed(22)
par(mfrow=c(2,3))
for(i in 1:5)
  {
    eps <- resid[sample(1:length(resid),replace=F)]
    plot(arima.sim(length(ldeaths)-10,model=list(ar=fit$ar),innov=eps))
  }
plot(ts(log(ldeaths)[11:length(ldeaths)]))

par(mfrow=c(1,1))
acf(resid^2)
acf(abs(resid))


#2. Simulation von MA-Prozessen

x <- arima.sim(500,model=list(ma=0.8))
acf(x)

#Kombination von AR und MA

x <- arima.sim(500,model=list(ar=c(0.9,-0.8),ma=c(0.8,-0.7)))
acf(x)


