#21.12.2004

load("serie9.RData")

##1. SARIMA-Modelle

##Anzahl Flugpassagiere
##KURZE BESCHREIBUNG : Der Datensatz airline enthlt die monatliche Anzahl
##                   abfliegender Flugpassagiere in den USA fr die Jahre
##                   1949-1960.

airl <- ts(scan("http://stat.ethz.ch/Teaching/Datasets/airline.dat"))

plot(airl)

#Differenzen-Bildung
plot(diff.ts(airl,lag=1,differences=1))

#--> nicht erfolgreich!

#mit saisonalen Differenzen (Saisonperiode 12)
plot(diff.ts(diff.ts(airl,lag=12,differences=2),lag=1,differences=1))

xdiff <- diff.ts(diff.ts(airl,lag=12,differences=2),lag=1,differences=1)

par(mfrow=c(1,2))
acf(xdiff)
acf(xdiff,type="partial")

aic.res <- matrix(0,ncol=5,nrow=5)
for(i in 1:5)
  {
    for(j in 1:5)
      {
        aic.res[i,j] <- arima(airl,order=c(j,1,0),seasonal=list(order=c(i,2,0),period=12))$aic
        print(c(i,j,aic.res[i,j]))
        
      }
  }

fit <- arima(airl,order=c(2,1,0),seasonal=list(order=c(4,2,0),period=12))
#Fit fuer SARIMA((2,1,0),(4,2,0)_12)

par(mfrow=c(1,2))
acf(fit$resid)
acf(fit$resid,type="partial")

par(mfrow=c(2,2))
acf(fit$resid,ylim=c(-0.5,1))
acf(fit$resid,type="partial",ylim=c(-0.5,0.3))
acf(xdiff,ylim=c(-0.5,1))
acf(xdiff,type="partial",ylim=c(-0.5,0.3))

par(mfrow=c(1,1))
qqnorm(fit$resid)

#Verbesserung (ausgehend von obigem Modell)
fit2 <- arima(airl,order=c(2,1,1),seasonal=list(order=c(4,2,1),period=12))
#Fit fuer SARIMA((2,1,1),(4,2,1)_12)

par(mfrow=c(1,2))
acf(fit2$resid)
acf(fit2$resid,type="partial")

par(mfrow=c(1,1))
qqnorm(fit2$resid)

lag.plot(fit2$resid,set.lags=1:4)

#Vorhersage
pred <- predict(fit2,n.ahead=12,se=T)

#Grafik: Daten, Vorhersage und Prognose-Intervall
plot(1:156,1:156,type="n",xlab="months",ylab="number of passengers",ylim=c(100,690))
lines(1:144,airl)
lines(145:156,pred$pred,col=2)
lines(145:156,pred$pred + 1.96 * pred$se,col=3)
lines(145:156,pred$pred - 1.96 * pred$se,col=3)


##2. mit log-Transformation
plot(log(airl))

#Differenzen-Bildung
plot(diff.ts(log(airl),lag=1,differences=1))

plot(diff.ts(diff.ts(log(airl),lag=12,differences=1),lag=1,differences=1))

xdiff <- diff.ts(diff.ts(log(airl),lag=12,differences=1),lag=1,differences=1)

par(mfrow=c(1,2))
acf(xdiff)
acf(xdiff,type="partial")

aic.res2 <- matrix(0,ncol=4,nrow=4)
for(i in 1:4)
  {
    for(j in 1:4)
      {
        aic.res2[i,j] <- arima(log(airl),order=c(j,1,0),seasonal=list(order=c(i,1,0),period=12))$aic
        print(c(i,j,aic.res2[i,j]))
        
      }
  }


fit3 <- arima(log(airl),order=c(4,1,0),seasonal=list(order=c(3,1,0),period=12))
#Fit fuer SARIMA((4,1,0),(3,1,0)_12)


par(mfrow=c(1,2))
acf(fit3$resid)
acf(fit3$resid,type="partial")

par(mfrow=c(2,2))
acf(fit3$resid,ylim=c(-0.5,1))
acf(fit3$resid,type="partial",ylim=c(-0.5,0.3))
acf(xdiff,ylim=c(-0.5,1))
acf(xdiff,type="partial",ylim=c(-0.5,0.3))


par(mfrow=c(1,1))
qqnorm(fit3$resid)

#Verbesserung (ausgehend von obigem Modell)
fit4 <- arima(log(airl),order=c(4,1,1),seasonal=list(order=c(3,1,1),period=12))
#Fit fuer SARIMA((4,1,1),(3,1,1)_12)

#nicht erfolgreich (bzgl. AIC)

lag.plot(fit3$resid,set.lags=1:4)


#Vorhersage
pred3 <- predict(fit3,n.ahead=12,se=T)

#Grafik: Daten, Vorhersage und Prognose-Intervall
par(mfrow=c(1,1))
plot(1:156,1:156,type="n",xlab="months",ylab="number of passengers",ylim=c(100,690))
lines(1:144,airl)
lines(145:156,exp(pred3$pred),col=2)
lines(145:156,exp(pred3$pred + 1.96 * pred3$se),col=3)
lines(145:156,exp(pred3$pred - 1.96 * pred3$se),col=3)

#Vergleich mit und ohne log-Transformation
par(mfrow=c(2,1))
plot(1:156,1:156,type="n",xlab="months",ylab="number of passengers",ylim=c(100,690))
lines(1:144,airl)
lines(145:156,pred$pred,col=2)
lines(145:156,pred$pred + 1.96 * pred$se,col=3)
lines(145:156,pred$pred - 1.96 * pred$se,col=3)

plot(1:156,1:156,type="n",xlab="months",ylab="number of passengers",ylim=c(100,690))
lines(1:144,airl)
lines(145:156,exp(pred3$pred),col=2)
lines(145:156,exp(pred3$pred + 1.96 * pred3$se),col=3)
lines(145:156,exp(pred3$pred - 1.96 * pred3$se),col=3)

par(mfrow=c(1,1))

plot(pred$pred,ylim=c(350,750))
lines(pred$pred + 1.96 * pred$se,col=3)
lines(pred$pred - 1.96 * pred$se,col=3)

lines(exp(pred3$pred),col=2)
lines(exp(pred3$pred + 1.96 * pred3$se),col=4)
lines(exp(pred3$pred - 1.96 * pred3$se),col=4)

legend(145,730,c("ohne log","ohne log","log","log"),lty=rep(1,4),col=c(1,3,2,4))

save(aic.res,aic.res2,airl,fit,fit2,fit3,fit4,file="serie9.RData")




